;verze eh118a, co noveho?
;- zadna zmena v Easy Hdd 1.18
;- bootuje BSROM 1.40, nikoliv 1.18
;- mirna optimalizace kodu na zacatku bootovani
;- pokud neni stistena klavesa, skoci se rovnou do BSROM bez bootovani (cca 1 sec.)
;- stisk SS po resetu= odpojeni MB Rom a skok do ZX Rom (jiz bylo v predchozich verzich)
;- stisk B po resetu= bootuj, pridano
;- zmena kompilatoru na SJASMPLUS
;- zdrojak upraven do jednoho (byly dva "booting" a "hlavni")


;Nove bootovani s autodetekci virtualnich image na CF karte



	output "eh118a.out"	;tento vysledek si flashnout do EPROM, pomoci programu "FLASH II" od 8BC.
		
		org	0
TAM		equ	32768
rom_d	equ 64		;definice stranek a portu, budou treba i v dalsim kodu Flashbootu
rom_e	equ 96
dos_e	equ 97
port	equ 23
		
		di	
START	ld sp,23999
	xor a
	ld i,a
	ld a,127	;testuj SS a B. Po stisku SS se odepne ROM v MBcku a nastrankuje se ROM ZX
	in a,(254)	;po stisku B probehne klasicky boot
	bit 1,a 	;pokud se nestiskne nic, skoci se do BSROM na reset sipkou hore (po kazdem
	jr nz,test_B	;zapnuti pocitace netreba prece bootovat, system je vzdy zalohovan v SRAM)
	ld hl,#D3AF;54191	;pri stisku SS se vykona na 16384 rutina xor a:out (port),a: rst 0
	ld (16384),hl
	ld hl,#C717;50967
	ld (16386),hl
	jp 16384

test_B	bit 4,a
	jr z,noloop	;stiskem B nutno bootovat jen tehdy, pokud se system poskodil

noboot	ld hl,rut
	ld de,16384
	push de
	ld bc,rut_len
	ldir
	ret

rut	ld a,rom_d
	out (port),a
	ld a,(#153F)	;testneme jaka je ROM pripnuta a podle toho skocime na reset 128K
	cp #B0		;(v pripade BSROMek, nebo na 0, v jinem pripade)
	jp z,#3906
	cp #B8
	jp z,#3978
	rst 0

;	ld bc,0		;vlozime do ERRSP hodnotu 0. takze na BSROMkach probehne "sipka hore" ok,
;	push bc		;(vdaka, Busy:),ale na ZX ROM to vyhodi chybu s nastavenim zasobniku na
;	ld (23613),sp	;ERRSP, takze nastane reset
;	call #16B0	;vycisteni editacni zony
;	ld a,#5E	;basicovy prikaz "sipka hore"
;	call #F81	;tento cely BASIC se neosvedcil, potrebuje korektni sys.promenne a ty
;	jp #12B4	;nemusi byt v RAM vubec pritomne
rut_len	equ $-rut



noloop		  ld      bc,20000	;cekaci smycka po resetu
loopbc          dec     bc
                ld      a,b
                or      c
                jr      nz,loopbc
		out	(254),a
		ld	hl,22528
		ld	de,22529
		xor	a
		ld	(hl),a
		ld	bc,768
		ldir
		ld 	hl,screen
		ld	de,TAM
		ld	bc,screen_len
		ldir
		ld	hl,RET
		ld	(TAM+4),hl
		call 	TAM
		ld	hl,presun
		ld	de,25000
		ld	bc,presun_len
		ldir
		jp	25000
RET		ret

presun		ld hl,startorg
		ld	de,presun2ram
		ld bc,16384-startorg
		ldir
		ld	a,129		;presun zbytek kodu z EPROM (obou stranek) do normalni RAM
		out	(port),a
		ld	hl,0
		ld	bc,16384
		ldir
		ld	a,128
		out	(port),a
		jp	presun2ram
presun_len	equ	$-presun

screen		incbin	eh118anoGS.bin
screen_len	equ	$-screen

startorg
		org presun2ram
start		ld	sp,23999	;na co je toto???
		ld	hl,16384
		ld	de,16385
		ld	(hl),l
		ld	bc,2
		ldir
		call	32768			;rozbal	dos banky
		ld	a,rom_e
		out	(port),a		;prestrankuj do banky 0 a povol zapis
		ld	hl,32768		;32768 - naladuj Basic do 'ROMky'
		ld	de,0
		ld	bc,16384
		ldir
		ld	a,dos_e			;naladuj BS Dos do 'RAMeti'
		out	(port),a		;nastrankuj BS Ramku a povol zapis
		ld	hl,32768+16384
		ld	de,0
		ld	bc,16384
		ldir
		ld	a,rom_d
		out	(port),a
		ld	hl,patch
		ld	de,32768
		ld	bc,patch_len
		ldir
		call	32768			;HDD Patch
		call	$3c9e			;Prepni do BS Dos rameti
		ld	a,$1E
		rst	$20
		ld	e,3
		ld	a,$13
		rst	$20
		ld	e,0
		ld	a,$14
		rst	$20
		ld	a,$30
		rst	$20
		ld	a,1
		out	(254),a
		ret
start_len	equ $-start

patch		incbin EH118_light_PVL.BIN
;patch		incbin EH118_light_GS.BIN
patch_len	equ	$-patch

dos	incbin packdos140.bin
presun2ram	equ	TAM-patch_len-start_len
presun2ramlen	equ $-start